#!/bin/bash
# ©2023 J. S. Gilstrap - All Rights Reserved.
# GPL ≥2.1  https://www.gnu.org/licenses
# geolocation IP lookup per unique ip (A.B.C.D).

Key=
DOM=domain.com
geoSrv="//api.ipgeolocation.io/ipgeo"
chrBuf=24
IP=$1 ; IP=${IP:0:15}
ref=${HTTP_REFERER#*://} ; ref=${ref%%/*}

case $ref in
	*${DOM}) ;;
	*) 
while read line ; do echo "$line" ; done <<EoF
Content-Type: text/html ; charset=utf-8

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html>
<head>
	<title>401 Unauthorized. Access Denied!</title>
	<meta http-equiv="Content-Type" content="text/html ; charset=utf-8">
	<meta name="author" content="J. S. Gilstrap">
</head>
<body>
<font size="5">401 Unauthorized. Access Denied!</font>
</body>
</html>
EoF
	exit 1
	;;
esac

while read line ; do echo "$line" ; done <<EoF
Content-Type: text/html ; charset=utf-8

<html>
<head>
	<title>IP GeoLocation ${IP}</title>
	<meta http-equiv="Content-Type" content="text/html ; charset=utf-8">
	<meta name="author" content="J. S. Gilstrap">
	<meta name="viewport" content="width=device-width, initial-scale=0.64, maxium-scale=1.5, minimum-scale=0.5">
	<style> body { width:576px; } </style>
</head>
<body text="#2d005a" bgcolor="#fff4ed">

<font size="3" face="'DejaVu Sans Mono','Andale Mono','PT Mono','Bitstream Vera Sans Mono','Nimbus Mono L',Monaco,'Liberation Mono','Free Mono','Sans Mono',Monospace">

<hr width="75%" size="5" color="#400080">
<center>
<font size="4">
<b>${IP}</b>
</font>
</center>
<hr width="75%" size="5" color="#400080">

EoF

while read line
do
	if [ -n "$line" ]
	then
		case $line in
			{|}) ;;
			  *)
				line=${line//\{} ; line=${line//\}} ; line=${line//\"} ; line=${line%,}
				line=${line/:/=} ; var=${line%=*} ; val=${line#*=} 
				[ "$var" = is_eu -o "$var" = is_dst -o "$var" = dst_savings ] && \
				{ [ "${val// }" = true -o  "${val// }" = 1 ] && val=Yes || val=No ; }

				case $var in
					hostname|city|latitude|longitude|languages|organization|code|symbol) var=${var^} ;;
					country_capital) var=Country_Capitol ;; state_prov) var=State/Province ;;
					country_tld) var=Country_TLD ;; ip) var=IP_Address ;; is_eu) var=Is_EU? ;;
					asn) var=AS_Number ;; geoname_id) var=GeoName_ID ;; offset) var=UTC_Offset ;;
					current_time) var=Current_Local_Time ;; current_time_unix) var=Current_UNIX__Time ;;
					is_dst) var=Is_DST? ;; dst_savings) var=Daylight_Savings_Time ;; isp) var=ISP ;;
					currency) name=Currency ; var=" " ;; time_zone) name=Time_Zone ; var=" " ;;
					name) var=$name ; name="" ;; district) var=District/County/Parish ;;
					country_flag) var=Country_Flag ; val="<img src=\"${val// }\" width=\"32\" height=\"18\">" ;;
					*_*) w1=${var%_*} ; w1=${w1^} ; w2=${var#*_} ; w2=${w2^} ; var=${w1}_${w2} ;;
				esac

				[ ${#var} -gt 1 ] && var=${var}:
				var=$(printf "%${chrBuf}b" "${var//_/ }")
				[ -n "$var" ] && printf "${var// /&nbsp;} ${val}<br>\n"
				;;
		esac
	fi
done < <(curl ${geoSrv}?apiKey=${Key}&ip=${IP})

printf "<br>\n<center>&copy;2023 J. S. Gilstrap - All Rights Reserved.</center>\n</body>\n</html>"

